

pro hxi_rebindata, data1_in=data1_in, data2_in=data2_in,$
                expt_in=expt_in, tarray_in = tarray_in, $
                data1_out=data1_out, data2_out=data2_out,$
                expt_out=expt_out, tarray_out = tarray_out, $
                avg_data = avg_data, $
                minexpt = minexpt, tbin_center = tbin_center
 
  expt = expt_in
  default, minexpt,1.
  default, tbin_center,0
  default, tarray_in, dblarr(n_elements(expt))
  
  exptset = [0.25,0.5,1.,4.] ;for HXI
  
  n_data = keyword_set(data1_in)+keyword_set(data2_in)
  n_dim1= SIZE(data1_in, /N_DIMENSIONS)
  size1 = SIZE(data1_in, /DIMENSIONS)
  if n_data eq 2 then begin
    size2 = SIZE(data2_in, /DIMENSIONS)
    n_dim2 = SIZE(data2_in, /N_DIMENSIONS)
  endif
  
  findshortexpt = where(expt le minexpt*0.99999, count_short)
  if count_short[0] ge 2 then begin
 
    allexptset = transpose( rebin( exptset, 4, n_elements(expt) ) )
    expt_temp = rebin(expt,n_elements(expt),4)/allexptset -1.
    expt_reg = expt

    for seti=0, n_elements(exptset)-1 do begin
      findexpt = where(abs( expt_temp[*,seti] ) le 0.1)
      if findexpt[0] ne -1 then expt_reg[findexpt] = exptset[seti]
    endfor

    expt_index = fix( total(expt_reg,/cumul)/(minexpt*1.0001) )
    u_expt_index =  (uniq(expt_index))
    nexpt = n_elements(u_expt_index)
    
    expt_out = fltarr(nexpt)
    tarray_out = dblarr(nexpt)
    data1_out = data1_in*0
    if n_data eq 2 then data2_out = data2_in*0
    
    for i_expt = 0, nexpt-1 do begin
      findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)
      
      case n_dim1 of
      1: begin
          data1_out = fltarr(nexpt)
        
          for i_expt = 0, nexpt-1 do begin
            findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)

            if nthisi eq 1 then begin
              data1_out[i_expt] = reform(  data1_in[findthisi] )
              expt_out[i_expt] = reform(  expt[findthisi] )
              tarray_out[i_expt] = reform(  tarray_in[findthisi] ) 
            endif else begin
              expt_out[i_expt] = total(  expt[findthisi] )
              if ~tbin_center then tarray_out[i_expt] = reform( tarray_in[findthisi[0]] ) else tarray_out[i_expt] = average( tarray_in[findthisi] )

              if keyword_set(avg_data) then begin
                data1_out[i_expt] = average( data1_in[findthisi] )
              endif else begin
                data1_out[i_expt] = total( data1_in[findthisi] )
              endelse
            endelse
          endfor
 
        end
      2: begin
          data1_out = fltarr(size1[0],nexpt)

          for i_expt = 0, nexpt-1 do begin
            findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)

            if nthisi eq 1 then begin
              data1_out[*, i_expt] = reform(  data1_in[*, findthisi] )
              expt_out[i_expt] = reform(  expt[findthisi] )
              tarray_out[i_expt] = reform(  tarray_in[findthisi] ) 
            endif else begin
              expt_out[i_expt] = total(  expt[findthisi] )
              if tbin_center eq 0 then tarray_out[i_expt] = reform( tarray_in[findthisi[0]] ) else tarray_out[i_expt] = total( tarray_in[findthisi] )

              if keyword_set(avg_data) then begin
                data1_out[*,i_expt] = average( data1_in[*,findthisi],2 )
              endif else begin
                data1_out[*,i_expt] = total( data1_in[*,findthisi],2 )
              endelse
            endelse
          endfor

        end
      3: begin
          data1_out = fltarr(size1[0],size1[1],nexpt)

          for i_expt = 0, nexpt-1 do begin
            findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)

            if nthisi eq 1 then begin
              data1_out[*,*, i_expt] = reform(  data1_in[*,*, findthisi] )
              expt_out[i_expt] = reform(  expt[findthisi] )
              tarray_out[i_expt] = reform(  tarray_in[findthisi] ) 
            endif else begin
              expt_out[i_expt] = total(  expt[findthisi] )
              if tbin_center eq 0 then tarray_out[i_expt] = reform( tarray_in[findthisi[0]] ) else tarray_out[i_expt] = total( tarray_in[findthisi] )

              if keyword_set(avg_data) then begin
                data1_out[*,*,i_expt] = average( data1_in[*,*,findthisi],3 )
              endif else begin
                data1_out[*,*,i_expt] = total( data1_in[*,*,findthisi],3 )
              endelse
            endelse
          endfor

        end
      else: print, 'not supported'  
      endcase
      
      if n_data eq 2 then begin
        case n_dim2 of
          1: begin
             data2_out = fltarr(nexpt)

            for i_expt = 0, nexpt-1 do begin
              findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)
               if nthisi eq 1 then begin
                data2_out[i_expt] = reform(  data2_in[findthisi] )
              endif else begin
                if keyword_set(avg_data) then begin
                  data2_out[i_expt] = average(  data2_in[findthisi] )
                endif else data2_out[i_expt] = total(  data2_in[findthisi] )
              endelse
            endfor
 
          end
          2: begin
            data2_out = fltarr(size2[0],nexpt)

            for i_expt = 0, nexpt-1 do begin
              findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)

              if nthisi eq 1 then begin
                data2_out[*, i_expt] = reform(  data2_in[*, findthisi] )
              endif else begin
                if keyword_set(avg_data) then begin
                  data2_out[*,i_expt] = average(  data2_in[*,findthisi],2 )
                endif else begin
                  data2_out[*,i_expt] = total(  data2_in[*,findthisi],2 )
                endelse
              endelse
            endfor

          end
          3: begin
            data2_out = fltarr(size2[0],size2[1],nexpt)

            for i_expt = 0, nexpt-1 do begin
              findthisi = where(expt_index eq expt_index[u_expt_index[i_expt]],nthisi)

              if nthisi eq 1 then begin
                data2_out[*,*, i_expt] = reform(  data2_in[*,*, findthisi] )
              endif else begin
                if keyword_set(avg_data) then begin
                  data2_out[*,*,i_expt] = average(  data2_in[*,*,findthisi],3 )
                endif else begin
                  data2_out[*,*,i_expt] = total(  data2_in[*,*,findthisi],3 )
                endelse
              endelse
            endfor 

          end
          else: print, 'not supported'
        endcase
      endif
 
    endfor

  endif else begin
    data1_out  = data1_in
    if n_data eq 2 then data2_out  = data2_in
    expt_out = expt
  endelse
 
end

