;Name:
;  hxi_get_recent_file
;Purpose:
;  获得最新的HXI文件
;Call sequence:
;  files= hxi_get_recent_file(files)
;Inputs:
;  files
;Outputs:
;  recent file
;
;History
;  weichen, 2022/02/19
;  weichen, 2023/04/17 add version id 'v'
;  weichen, 2023/11/06 Suitable for searching multiple files and multiple versions

FUNCTION HXI_GET_RECENT_FILE, files,count=count

break_file,files,disk,dir,fname,ext,/last

ftime= STRMID(fname, 0,29)
ftime2= ftime[uniq(ftime)]
nftime= n_elements(ftime2)

;2023/11/06
if nftime gt 1 then begin
  
  outfiles = strarr(nftime)
  for i=0,nftime -1 do begin
    tmpfname = str_match(files, ftime2[i])
    outfiles[i]= HXI_GET_RECENT_FILE(tmpfname) 
  endfor
   count= nftime
   RETURN, outfiles
endif else begin
  
  vers = FIX(STRMID(fname, 1,2, /reverse_offset))

  rc_txt  = 'v'+num2str( MAX(vers), format='(I02)')

  rc_name = str_match(fname, rc_txt)
  j= WHERE(fname EQ rc_name)
  ;file= disk[i]+dir[i]+rc_name+ext[i]
  outfiles= files[j[0]]
  count= n_elements(outfiles)
  RETURN, outfiles

endelse


END

