;+
; Mission     : ASO-S/HXI
; Name        : hxi_get_pattern4imaging
; Purpose     : get pattern for the given parameters
; Category    : imaging
; Syntax      :
; Inputs      :
;
; Outputs     :
;
; Outputs (OPTIONAL):
; History     :
;       2021/11/07, Yang Su, a series of test versions.
;       2022/03/23, Yang Su, first beta version for simulated data; 
;       2022/08, 2022/10, Yang Su , add support for correction of pointing shifts

pro hxi_get_pattern4imaging,  earray, loc_in,fov_in,rolla, patt_psize,$
          nxy, nocalib, patt, fulld=fulld,cent_xy=cent_xy, patt_shift=patt_shift   ;nocalib, 231222
          
   default, fulld, 0  ;yang, 221002
   dir_hxi=getenv('hxi_db')
 
   if fulld eq 1 then  loc_in=[0.,0.]
   
   fov_in=nxy*patt_psize
   ;221002, Yang, 
   this_energy= 10.^( average( alog10(earray)) )
   
   HXI_get_patt, loc_in, fov_in+100., patt_psize, this_energy,  patterns, nocalib=nocalib, savefile=0 
   
;   cent_xy_new = cent_xy*0.
;   theta1 = 44.6
;   cent_xy_new[0,*] =  cent_xy[0,*]*cos(theta1/180.*!pi) + cent_xy[1,*]*sin(theta1/180.*!pi)
;   cent_xy_new[1,*] =  cent_xy[1,*]* cos(theta1/180.*!pi) - cent_xy[0,*]* sin(theta1/180.*!pi)
;   cent_xy = cent_xy_new
   
    nxy_new = (size(patterns))[1]
    if keyword_set(cent_xy) then begin
        ntimes= (size(cent_xy))[2]
        new_patterns= make_array( (size(patterns))[1],(size(patterns))[2],(size(patterns))[3], ntimes)
        new_patterns[*,*,*,0] =  patterns[*,*,*]
        ;for i = 1,ntimes-1 do  new_patterns[*,*,*,i] = shift_img(reform(patterns), -rebin( reform( (cent_xy[*,i]-cent_xy[*,0])/patt_psize ),2,91,/sample)  )
        
        ;240108,YS
        for i = 0,ntimes-1 do  new_patterns[*,*,*,i] = shift_img(reform(patterns),   -rebin( reform( (reform(cent_xy[*,i])-loc_in)/patt_psize ),2,91,/sample)  )

        ;221002, yang
;        patt = patterns[nxy/2:3*(nxy/2),nxy/2:3*(nxy/2),* ]
;        patt_shift = new_patterns[nxy/2:3*(nxy/2),nxy/2:3*(nxy/2),*,* ]
        patt = patterns[(nxy_new/2-nxy/2):((nxy_new/2-nxy/2)+nxy-1),(nxy_new/2-nxy/2):((nxy_new/2-nxy/2)+nxy-1),* ]
        patt_shift = new_patterns[(nxy_new/2-nxy/2):((nxy_new/2-nxy/2)+nxy-1),(nxy_new/2-nxy/2):((nxy_new/2-nxy/2)+nxy-1),*,* ]
    endif else begin
        patt = patterns[(nxy_new/2-nxy/2):((nxy_new/2-nxy/2)+nxy-1),(nxy_new/2-nxy/2):((nxy_new/2-nxy/2)+nxy-1),* ]
    endelse
 
end