;;+
;Name:
;    HXI_FWHM 
;Purpose
;    Returns the fwhm resolution vs energy. Returns value in keV
;
;Inputs:
;    e - Energy in keV, a vector,  normal range 10-400.0 keV
;    par - default, 1.0, scalar, electronic noise component of overall resolution broadening, excludes Hall tailing
;History
;    weichen, 2022/06/27
;    weichen, 2024/02/02, fix the value of eta32 from 0.22 to 0.2


FUNCTION HXI_FWHM, e, par
  
  default, par, 1.0
  eta=0.20 * sqrt(32.)
  return, eta* sqrt( e )* par
end