;+
; Mission:
;   ASO-S/HXI
; Purpose: 
;   return photon energy for drm
; Input:
;   ct_edges -- array of energy edges of e-bins
; Output:
;   Ph_edges -- array of energy edges of photons in drm, $
;                 maximum value is twice of maximum of CT_EDGES or 600keV
; History:
;   Weichen, 2022/01/11


function hxi_srm_extend_ph_edges, ct_edges

  ct1 = get_edges( ct_edges, /edges_1 )
  energy_m = max( ct1 )
  nchan = n_elements(ct1) - 1
  ph_energy_m = 2 * energy_m < 600.
  nchan_p  = ceil(nchan / 10. ) < 10
  return, [ct_edges, energy_m + $
    (findgen(nchan_p+1))[1:*] * (ph_energy_m-energy_m)/nchan_p ]
end