;+
; Mission : ASO-S/HXI
; Puropse:
; Generate composite components that enable the user to select a collimators (for spectrum)
; 
; History:
; Writen by Fanxiaoyu Xia, 2021/11/10
; 2023.11.03, Changxue Chen, Zhentong Li, changed detector choosing segment

function hxi_coll_widget_event, event

  base = event.handler
  stash = widget_info(base, /child)
  widget_control, stash, get_uvalue=state
  widget_control, event.id, get_uvalue=uvalue

  if strlen(uvalue) le 2 then begin
    num=fix(uvalue)
    state.coll_index[num] = event.select
    ;print,state.coll_index
    widget_control, stash, set_uvalue=state
  endif

;  if uvalue eq 'all_1' then begin
;    state.coll_index[0:2]=1
;    for i=0,2 do begin
;      widget_control, state.w_segs[i], set_button = 1
;    endfor
;    widget_control, stash, set_uvalue=state
;  endif
;
;  if uvalue eq 'all_2' then begin
;    state.coll_index[3:7]=1
;    for i=3,7 do begin
;      widget_control, state.w_segs[i], set_button = 1
;    endfor
;    widget_control, stash, set_uvalue=state
;  endif

if uvalue eq 'combine' then begin
  state.combine_check=abs(state.combine_check-1)
  widget_control, state.w_segs[8], set_button = state.combine_check
;  print, state.combine_check
  widget_control, stash, set_uvalue=state
endif

if uvalue eq 'combine_bkg' then begin
  state.combine_bkg_check=abs(state.combine_bkg_check-1)
  widget_control, state.w_segs[9], set_button = state.combine_bkg_check
  widget_control, stash, set_uvalue=state
endif


  ret = {id: base, top: event.top, handler: 0L}
  return,ret
end

function hxi_coll_widget, parent, uvalue=uvalue,cdefault = cdefault, coll_comb=coll_comb
  device,get_screen_size=sc
  fspace = .005*sc(0)
  w_segs = lonarr(10)  ;1103
  w_base = widget_base ( parent, $
    event_func='hxi_coll_widget_event', /base_align_left, $
;    /column, uvalue=uvalue, y_scroll_size=150, $
    /column, uvalue=uvalue, $
    title='Collimator/Detector Options', $
    /frame)

  w_top = widget_base (w_base, /column)
  w_collbase1 = widget_base (w_top, column=3, /align_left)
  w_labels = widget_label ( w_collbase1, value='Detector ID:', /align_left)
  
  
  w_collbase2 = widget_base(w_top, /column, xpad=0)
  w_row1 = widget_base( w_collbase2, /row, space= 0, xpad=0)
  w_seg1 = widget_base(w_row1, /nonexclusive, /row, space=1.*fspace, xpad=0 )
  
    w_segs[0] = widget_button( w_seg1, $
      value='D92 (t1)',uvalue='0' )
    w_segs[1] = widget_button( w_seg1, $
      value='D93 (t2)', uvalue='1' )
    w_segs[2] = widget_button( w_seg1, $
      value='D94 (t3)  ', uvalue='2')
    w_segs[8] = widget_button( w_seg1, $
      value='Combine', uvalue='combine')  ;1103
      
    w_row2 = widget_base( w_collbase2, /row, space=0, xpad=0)
    w_seg2 = widget_base(w_row2, /nonexclusive, space=1.*fspace, /row )
    w_segs[3] = widget_button( w_seg2, value='D95 (b1)', uvalue='3')
    w_segs[4] = widget_button( w_seg2, value='D96 (b2)',uvalue='4')
;    w_segs[5] = widget_button( w_seg2, value='D97',uvalue='5')
;    w_segs[6] = widget_button( w_seg2, value='D98',uvalue='6')
    w_segs[7] = widget_button( w_seg2, value='D99 (b5)  ',uvalue='7')
    w_segs[9] = widget_button( w_seg2, value='Combine BKG',uvalue='combine_bkg')
    
;    tmp = widget_button(w_row1, value='all', uvalue='all_1')
;    tmp = widget_button(w_row2, value='all BkG', uvalue='all_2')

    w_row3 = widget_base( w_collbase2, /row, space=0, xpad=0)
    w_seg3 = widget_base(w_row3, /nonexclusive, space=1.5*fspace, /row )
    w_segs[5] = widget_button( w_seg3, value='D97 (b3, edge)',uvalue='5')
    w_segs[6] = widget_button( w_seg3, value='D98 (b4, edge)',uvalue='6')
;    w_row4 = widget_base ( w_collbase2, /row, space=0, xpad=0)
;    w_buttrow = widget_base ( w_row4, /row, space=0 )
  
;  if not keyword_set(cdefault) then cdefault=[0,0,1,0,0,0,0,0]
  checkvar, cdefault, [0,0,1,0,0,0,0,0]
  checkvar, coll_comb, [0, 0]
  coll_index=cdefault
  
  for i=0,7 do begin
    widget_control, w_segs[i], set_button = cdefault[i]
  endfor
  state= { w_base: w_base, w_segs: w_segs, $
    coll_index:coll_index, cdefault:cdefault, $
    combine_check:coll_comb[0], combine_bkg_check:coll_comb[1]}  ; 1103
  widget_control, widget_info(w_base, /child ), set_uvalue=state
  return, w_base
end