;+
; Mission     : ASO-S/HXI
; Name: hxi_fpage
; Purpose: Put up a splash screen on initial window in hxi GUI
; 
; History:
;  Writen by Fanxiaoyu Xia, 2022/07/15


pro hxi_fpage

  device,get_visual_name=visual_name
  truecolor = visual_name eq 'TrueColor'

  font_save = !p.font
  !p.font = 0

  if truecolor then begin
    tvlct, r, g, b, /get
    linecolors
  endif

  get_font, font, big_font=big_font, small_font=small_font, huge_font=huge_font

  device, set_font=huge_font
  color = truecolor ? 10 : 255
  xyouts, .5, .9, 'HXI DATA ANALYSIS', charsize=2., color=color, /normal, align=.5

  device, set_font=big_font
  color = truecolor ? 4 : 255
  text = ['Use the Menu to:', $
    '!C   1. Load saved HXI maps or other maps', $
    '!C!C   2. Set plot preferances', $
    '!C!C!C   3. Configure plot file', $
    '!C!C!C!C   4. Creat plot file', $
    '!C!C!C!C!C   5. Export data']
  xyouts, .1, .75, text, charsize=2., color=color, /normal

  device, set_font=big_font
  ; print all lines, except last (date of last change) in red.  last line is green.
  color = truecolor ? 3 : 255
  text2 = ['HXI software changes are documented at', $
    '!Chttp://aso-s.pmo.ac.cn/sodc/analysisSoftware.jsp']
  xyouts, .1, .3, text2, charsize=2.,color=color, /normal
  color = truecolor ? 5 : 255
  text3 = ['!C!C!C HXI GUI Beta Version 1.42 '] ;230513,YS; 231221, YS;240210,YS; 240308, YS
  xyouts, .55, .25, text3, charsize=2.,color=color, /normal 
  
  prstr,[' ',strrempat('>>> '+text3,'!C',/all)], /nomore  
  
  !p.font = font_save
  if truecolor then tvlct, r, g, b

  ;set font back to normal size for device
  device, set_font=font

end
